import numpy as np
import cv2
from cv2 import *
import sys

im = cv2.imread('photo1.png')
im = cv2.bilateralFilter(im, 9, 75, 75)
im = cv2.fastNlMeansDenoisingColored(im,None,10,10,7,21)
hsv_img = cv2.cvtColor(im, cv2.COLOR_BGR2HSV)

whiteCount = 0
greenCount = 0
blueCount = 0
orangeCount = 0
yellowCount = 0

xArray = []
yArray = []
surface = ['R','R','R','R','R','R','R','R','R']

WHITE_COLOR_MIN = np.array([70, 10, 130],np.uint8)
WHITE_COLOR_MAX = np.array([180, 110, 255],np.uint8)

GREEN_COLOR_MIN = np.array([60, 110, 110],np.uint8)
GREEN_COLOR_MAX = np.array([100, 220, 250],np.uint8)

BLUE_COLOR_MIN = np.array([100, 100, 100],np.uint8)
BLUE_COLOR_MAX = np.array([130, 255, 255],np.uint8)

ORANGE_COLOR_MIN = np.array([5, 150, 150],np.uint8)
ORANGE_COLOR_MAX = np.array([15, 235, 250],np.uint8)

YELLOW_COLOR_MIN = np.array([20, 100, 100],np.uint8)
YELLOW_COLOR_MAX = np.array([40, 255, 255],np.uint8)



frame_threshed = cv2.inRange(hsv_img, WHITE_COLOR_MIN, WHITE_COLOR_MAX)
imgray = frame_threshed
ret,thresh = cv2.threshold(frame_threshed,127,255,0)
cv2.imshow("Show",thresh)
im2, contours, hierarchy = cv2.findContours(thresh, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
for cnt in contours:
    x,y,w,h = cv2.boundingRect(cnt)
    if (w*h > 40000):
        xArray.append(x)
        yArray.append(y)
        cv2.rectangle(im, (x,y),(x+w,y+h),(0,255,0),5)
        whiteCount += 1

frame_threshed = cv2.inRange(hsv_img, GREEN_COLOR_MIN, GREEN_COLOR_MAX)
imgray = frame_threshed
ret,thresh = cv2.threshold(frame_threshed,127,255,0)
cv2.imshow("Show",thresh)
im2, contours, hierarchy = cv2.findContours(thresh, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
for cnt in contours:
    x,y,w,h = cv2.boundingRect(cnt)
    if (w*h > 40000):
        xArray.append(x)
        yArray.append(y)
        cv2.rectangle(im, (x,y),(x+w,y+h),(0,255,0),5)
        greenCount += 1

frame_threshed = cv2.inRange(hsv_img, BLUE_COLOR_MIN, BLUE_COLOR_MAX)
imgray = frame_threshed
ret,thresh = cv2.threshold(frame_threshed,127,255,0)
cv2.imshow("Show",thresh)
im2, contours, hierarchy = cv2.findContours(thresh, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
for cnt in contours:
    x,y,w,h = cv2.boundingRect(cnt)
    if (w*h > 40000):
        xArray.append(x)
        yArray.append(y)
        cv2.rectangle(im, (x,y),(x+w,y+h),(0,255,0),5)
        blueCount += 1

frame_threshed = cv2.inRange(hsv_img, ORANGE_COLOR_MIN, ORANGE_COLOR_MAX)
imgray = frame_threshed
ret,thresh = cv2.threshold(frame_threshed,127,255,0)
cv2.imshow("Show",thresh)
im2, contours, hierarchy = cv2.findContours(thresh, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
for cnt in contours:
    x,y,w,h = cv2.boundingRect(cnt)
    if (w*h > 40000):
        xArray.append(x)
        yArray.append(y)
        cv2.rectangle(im, (x,y),(x+w,y+h),(0,255,0),5)
        orangeCount += 1

frame_threshed = cv2.inRange(hsv_img, YELLOW_COLOR_MIN, YELLOW_COLOR_MAX)
imgray = frame_threshed
ret,thresh = cv2.threshold(frame_threshed,127,255,0)
cv2.imshow("Show",thresh)
im2, contours, hierarchy = cv2.findContours(thresh, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
for cnt in contours:
    x,y,w,h = cv2.boundingRect(cnt)
    if (w*h > 40000):
        xArray.append(x)
        yArray.append(y)
        cv2.rectangle(im, (x,y),(x+w,y+h),(0,255,0),5)
        yellowCount += 1


cv2.imshow("Show",im)
cv2.imwrite("extracted.jpg",im)

xMin = sys.maxsize
xMax = -sys.maxsize - 1

for x in xArray:
    if (x < xMin):
        xMin = x
    if (x > xMax):
        xMax = x

yMin = sys.maxsize
yMax = -sys.maxsize - 1

for y in yArray:
    if (y < yMin):
        yMin = y
    if (y > yMax):
        yMax = y

xMid = (xMin + xMax) / 2
xRange = (xMax - xMin) /4

yMid = (yMin + yMax) / 2
yRange = (yMax - yMin) /4

for idx, x in enumerate(xArray):
    if x > xMin - xRange and x < xMin + xRange:
        xArray[idx] = 0
    if x > xMid - xRange and x < xMid + xRange:
        xArray[idx] = 1
    if x > xMax - xRange and x < xMax + xRange:
        xArray[idx] = 2

for idx, y in enumerate(yArray):
    if y > yMin - yRange and y < yMin + yRange:
        yArray[idx] = 0
    if y > yMid - yRange and y < yMid + yRange:
        yArray[idx] = 1
    if y > yMax - yRange and y < yMax + yRange:
        yArray[idx] = 2

for idx, x in enumerate(xArray[0:whiteCount]):
    index = yArray[idx] * 3 + xArray[idx];
    surface[index] = 'W'

for idx, x in enumerate(xArray[whiteCount:whiteCount+greenCount]):
    index = yArray[idx+whiteCount] * 3 + xArray[idx+whiteCount];
    surface[index] = 'G'

for idx, x in enumerate(xArray[whiteCount+greenCount:whiteCount+greenCount+blueCount]):
    index = yArray[idx+whiteCount+greenCount] * 3 + xArray[idx+whiteCount+greenCount];
    surface[index] = 'B'

for idx, x in enumerate(xArray[whiteCount+greenCount+blueCount:whiteCount+greenCount+blueCount+orangeCount]):
    index = yArray[idx+whiteCount+greenCount+blueCount] * 3 + xArray[idx+whiteCount+greenCount+blueCount];
    surface[index] = 'O'

for idx, x in enumerate(xArray[whiteCount+greenCount+blueCount+orangeCount:whiteCount+greenCount+blueCount+orangeCount+yellowCount]):
    index = yArray[idx+whiteCount+greenCount+blueCount+orangeCount] * 3 + xArray[idx+whiteCount+greenCount+blueCount+orangeCount];
    surface[index] = 'Y'

print(surface)

